/*
 * RotateAroundOriginByAngleAction.hpp
 *
 *  Created on: Aug 06, 2010
 *      Author: heber
 */

#ifndef ROTATEAROUNDORIGINBYANGLEACTION_HPP
#define ROTATEAROUNDORIGINBYANGLEACTION_HPP

#include "Actions/Action.hpp"

class MoleculeListClass;
class Vector;

void MoleculeRotateOrigin(Vector &Axis);

class MoleculeRotateAroundOriginByAngleAction : public Action {
  friend void MoleculeRotateAroundOriginByAngle(const Vector &Axis, double angle);

public:
  MoleculeRotateAroundOriginByAngleAction();
  virtual ~MoleculeRotateAroundOriginByAngleAction();

  bool canUndo();
  bool shouldUndo();

  virtual const std::string getName();
protected:
  virtual Dialog * fillDialog(Dialog *dialog);
private:
  virtual Action::state_ptr performCall();
  virtual Action::state_ptr performUndo(Action::state_ptr);
  virtual Action::state_ptr performRedo(Action::state_ptr);

  static const char NAME[];
};


#endif // ROTATEAROUNDORIGINBYANGLEACTION_HPP
